{
********************************************************************************

MyPlaylist v1.0 by Nikol@y aka NITROGEN

********************************************************************************
}

unit MyPlaylist;

interface

uses
  Windows, ShellAPI, Forms, SysUtils, Messages, Dialogs, Classes, Controls,
  Graphics, Types, StrUtils;

type
  TMyPlaylist = class(TCustomControl)
  private
  { Private declarations }

    FShowDuration, FShowNumber: Boolean;
    FPosition: integer;
    Tracking: integer;
    ItemHeight: integer;
    X1, Y1: Integer;
    FItemSelect_BackColor: TColor;
    FItemSelect_FontColor: TColor;
    FItemTrack_BackColor: TColor;
    FItemTrack_FontColor: TColor;
    FItem_BackColor: TColor;
    FItem_FontColor: TColor;
    PlaylistTitles: TStringList;
    PlaylistPaths: TStringList;
    PlaylistDurations: TStringList;
    PlaylistSelection: TStringList;
    FOnPaint: TNotifyEvent;

{******************************************************************************}

    procedure SetItemSelect_BackColor(Value: TColor);
    procedure SetItemSelect_FontColor(Value: TColor);
    procedure SetItemTrack_BackColor(Value: TColor);
    procedure SetItemTrack_FontColor(Value: TColor);
    procedure SetItem_BackColor(Value: TColor);
    procedure SetItem_FontColor(Value: TColor);
    procedure SetShowDuration(Value: Boolean);
    procedure SetShowNumber(Value: Boolean);

{******************************************************************************}

  protected
  { Protected declarations }

    procedure Paint; override;
    procedure WMDROPFILES (var Msg: TMessage); message WM_DROPFILES;

{******************************************************************************}

procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
procedure MouseMove (Shift: TShiftState; X, Y: Integer); override;
procedure KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
procedure DblClick; override;

{******************************************************************************}

  public
  { Public declarations }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Add_File(FileName: string);
    procedure Add_Files(Files: TStrings);

    procedure LoadPlaylist_PLS(FileName: string);
    procedure LoadPlaylist_M3U(FileName: string);
    procedure SavePlaylist_M3U(FileName: string; FullPath: boolean);

    procedure Delete_Item(Item: integer);
    procedure ClearList;
    function  Count: Integer;
    function  GetTracking: Integer;
    procedure SetNewItemTrack(Item: Integer);
    procedure SetNewItemSelect(Item: Integer);
    function  GetItemFiles: TStrings;
    procedure SetPosition(Value: integer);
    function  GetItemHeight: integer;
  published
  { Published declarations }

    property Enabled;
    property Visible;
    property ShowHint;
    property Font;

{******************************************************************************}

    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnKeyDown;
    property OnKeyUp;
    property OnKeyPress;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnExit;
    property OnEnter;
    property OnDragOver;
    property OnDragDrop;
    property OnDblClick;

{******************************************************************************}

    property ShowDuration: Boolean read FShowDuration write SetShowDuration;
    property ShowNumber: Boolean read FShowNumber write SetShowNumber;
    property ItemSelect_BackColor: TColor read FItemSelect_BackColor write SetItemSelect_BackColor;
    property ItemSelect_FontColor: TColor read FItemSelect_FontColor write SetItemSelect_FontColor;
    property ItemTrack_BackColor: TColor read FItemTrack_BackColor write SetItemTrack_BackColor;
    property ItemTrack_FontColor: TColor read FItemTrack_FontColor write SetItemTrack_FontColor;
    property Item_BackColor: TColor read FItem_BackColor write SetItem_BackColor;
    property Item_FontColor: TColor read FItem_FontColor write SetItem_FontColor;

end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Standard', [TMyPlaylist]);
end;

{TMyPlaylist}

{******************************************************************************}

constructor TMyPlaylist.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:= TForm(AOWner);
  Width := 225;
  Height := 300;

  Font.Name := 'Tahoma';
  Font.Size := 9;
  Font.Height := -12;

  FShowDuration := True;
  FShowNumber := True;
  
  ItemSelect_BackColor := clBlue;
  ItemSelect_FontColor := clYellow;
  ItemTrack_BackColor := clRed;
  ItemTrack_FontColor := clWhite;
  Item_BackColor := clBlack;
  Item_FontColor := clLime;

  PlaylistTitles := TStringList.Create;
  PlaylistPaths := TStringList.Create;
  PlaylistDurations := TStringList.Create;
  PlaylistSelection := TStringList.Create;

  Tracking := -1;

  DragAcceptFiles(Self.Handle, true);

  Paint;
end;

{******************************************************************************}

destructor TMyPlaylist.Destroy;
begin
PlaylistTitles.Free;
PlaylistPaths.Free;
PlaylistDurations.Free;
PlaylistSelection.Free;
inherited Destroy;
end;

{******************************************************************************}

procedure TMyPlaylist.Paint;
var
i, j: integer;
s: string;
s_rect: TRect;
begin
inherited;
Canvas.Brush.Color := FItem_BackColor;
Canvas.FillRect(Rect(0,0,Width,Height));

if PlaylistTitles.Count > 0 then
begin
for i := 0 to PlaylistTitles.Count-1 do
begin
if FShowNumber then
//  + 
s := IntToStr(i+1) + '. ' + PlaylistTitles.Strings[i]
else
//  
s := PlaylistTitles.Strings[i];

Canvas.Font := Font;
//  
ItemHeight := 2 + Canvas.TextHeight(s) + 2;

//  
if i = Tracking then
begin
//   
Canvas.Brush.Color := FItemTrack_BackColor;
Canvas.Font.Color := FItemTrack_FontColor
end else
//  
begin
//  
Canvas.Brush.Color := FItem_BackColor;
Canvas.Font.Color := FItem_FontColor
end;
//   
Canvas.FillRect(Rect(0,i*ItemHeight-(FPosition*ItemHeight),Width,(i*ItemHeight+ItemHeight)-(FPosition*ItemHeight)));

if FShowDuration then
// 
Canvas.TextOut((Self.Width-(Canvas.TextWidth(PlaylistDurations[i]))-4),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight),PlaylistDurations[i])
else
// . 
Canvas.TextOut((Self.Width-(Canvas.TextWidth(''))-4),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight),'');

//   
if FShowDuration then
s_rect := Rect(1,(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight), Self.Width-(Canvas.TextWidth(PlaylistDurations[i])+5),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight)+Canvas.TextHeight(s))
else
s_rect := Rect(1,(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight), Self.Width-2,(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight)+Canvas.TextHeight(s));

//  
DrawTextEx(Canvas.Handle, PChar(s),Length(s), s_rect, DT_WORD_ELLIPSIS, nil);

// 
if Assigned(FOnPaint) then FOnPaint(Self);
end;
end;
end;

{******************************************************************************}

procedure TMyPlaylist.WMDROPFILES (var Msg: TMessage);
var    
i, amount, size: integer;
Filename: PChar;
begin
inherited;
Amount := DragQueryFile(Msg.WParam, $FFFFFFFF, Filename, 255);
for i := 0 to (Amount - 1) do
begin
size := DragQueryFile(Msg.WParam, i , nil, 0) + 1;
Filename:= StrAlloc(size);
DragQueryFile(Msg.WParam,i , Filename, size);
if ExtractFileExt(Filename) = '.pls' then
LoadPlaylist_PLS(StrPas(Filename))
else
if ExtractFileExt(Filename) = '.m3u' then
LoadPlaylist_M3U(StrPas(Filename))
else
Add_File(StrPas(Filename));

StrDispose(Filename);
end;
DragFinish(Msg.WParam);    
end;

{******************************************************************************}

procedure TMyPlaylist.SetItemSelect_BackColor(Value: TColor);
begin
FItemSelect_BackColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.SetItemSelect_FontColor(Value: TColor);
begin
FItemSelect_FontColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.SetItemTrack_BackColor(Value: TColor);
begin
FItemTrack_BackColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.SetItemTrack_FontColor(Value: TColor);
begin
FItemTrack_FontColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.SetItem_BackColor(Value: TColor);
begin
FItem_BackColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.SetItem_FontColor(Value: TColor);
begin
FItem_FontColor := Value;
Invalidate;
end;

{******************************************************************************}

procedure TMyPlaylist.Add_File(FileName: string);
begin
If FileExists(FileName) = false then exit;
PlaylistTitles.Add(ExtractFileName(FileName));
PlaylistPaths.Add(FileName);
PlaylistDurations.Add('03:15'); //  
Paint;
end;

{******************************************************************************}

procedure TMyPlaylist.Add_Files(Files: TStrings);
var
i: integer;
begin
for i := 0 to Files.Count-1 do
begin
if FileExists(Files[i]) = false then exit;
PlaylistTitles.Add(ExtractFileName(Files[i]));
PlaylistPaths.Add(Files[i]);
PlaylistDurations.Add('04:15'); //  
Paint;
end;
end;

{******************************************************************************}

procedure TMyPlaylist.LoadPlaylist_PLS(FileName: string);
var
f:textfile;
s:string;
i,j,k:integer;
begin
if lowercase(ExtractFileExt(FileName)) = '.pls' then
begin
assignfile(f,FileName);
reset(f);
repeat
readln(f,s);
s:=trim(s);

// ...
if lowercase(copy(s,0,5))='title' then
begin
i:=-1;
repeat
i:=i+1;
until(copy(s,i,1)='=');
PlaylistTitles.Add(copy(s,i+1,length(s)));
end;

// ...
if lowercase(copy(s,0,4))='file' then
begin
j:=-1;
repeat
j:=j+1;
until(copy(s,j,1)='=');
PlaylistPaths.Add(copy(s,j+1,length(s)));
end;

// ...
if lowercase(copy(s,0,6))='length' then
begin
k:=-1;
repeat
k:=k+1;
until(copy(s,k,1)='=');
PlaylistDurations.Add(Format('%d:%.2d', [StrToInt(copy(s,k+1,length(s))) div 60, StrToInt(copy(s,k+1,length(s))) mod 60]))
end;

until(eof(f)=true);
closefile(f);
Paint;
end;
end;

{******************************************************************************}
//    - 
function NotFullPathToFullPath(FM3U, FM: string): string;
var
  Ress: string;
begin
  Ress := '';
  Result := '';
//  1-  '\',     
  if FM[1] = '\' then
  begin
    Result := ExtractFileDrive(FM3U) + FM;
    exit;
  end else
  begin
//   m3u +    
    if FileExists(ExtractFilePath(FM3U) + FM) then
    begin
      Result := ExtractFilePath(FM3U) + FM;
      exit;
    end;
//     ?
    if FileExists(FM) then
    begin
      Result := FM;
      exit;
    end;
  end;
end;

{******************************************************************************}

procedure TMyPlaylist.LoadPlaylist_M3U(Filename:string);
var
List: TStringList;
i, n: integer;
s, a: string;
begin
List := TStringList.Create;
try
//  M3U'
List.LoadFromFile(FileName);
for i := 0 to List.Count - 1 do
begin
//      
if List.Strings[0] = '#EXTM3U' then
begin
s := List.Strings[i];
if s[1] <> '#' then
begin
//    
s := NotFullPathToFullPath(FileName, s);
// ...
PlaylistPaths.Add(s);
end else
begin
if s <> '#EXTM3U' then
begin
Delete(S, 1, 8);
a := '';
n := 1;
repeat
a := a + s[n];
Inc(n);
until s[n] = ',';
Delete(S, 1, Length(a) + 1);
// ...
PlaylistTitles.Add(s);
// ...
PlaylistDurations.Add(Format('%d:%.2d', [StrToInt(a) div 60, StrToInt(a) mod 60]));
end;
end;
end;
end;
finally
List.Free;
end;
Paint;
end;

{******************************************************************************}
//   - 
function MinToSec(tim: string): string;
var
n: integer;
a: string;
begin
n := 1;
a := '';
repeat
a := a + tim[n];
Inc(n);
until tim[n] = ':';
Delete(tim, 1, Length(a) + 1);
Result := IntToStr((StrToInt(a) * 60) + StrToInt(tim));
end;

{******************************************************************************}
//    - 
function ExtNotFullPath(FM3U, FM: string): string;
var
i: integer;
Ress: string;
begin
  Ress := '';
  Result := '';
for i := 1 to Length(FM3U) do
begin
if FM3U[i] = FM[i] then
begin
Ress := Ress + FM3U[i];
if FM3U[i] = '\' then Result := Ress;
end else
exit;
end;
end;

{******************************************************************************}

procedure TMyPlaylist.SavePlaylist_M3U(FileName: string; FullPath: boolean);
var
List: TStringList;
i: integer;
b, s: string;
begin
List := TStringList.Create;
List.Add('#EXTM3U'); // !!!   !!!
for i := 0 to PlaylistTitles.Count-1 do
begin
s := '';
//    + 
List.Add('#EXTINF:' + MinToSec(PlaylistDurations[i]) + ',' + PlaylistTitles[i]);

if FullPath = false then
//   , 
begin
b := ExtNotFullPath(FileName, PlaylistPaths[i]);
if Length(b) < Length(ExtractFilePath(FileName)) then
begin
s := PlaylistPaths[i];
if b<>'' then
Delete(s, 1, 2);
end else
s := AnsiReplaceText(PlaylistPaths[i], b, '');
end else
//   , 
s := PlaylistPaths[i];

List.Add(s);
end;
List.SaveToFile(FileName);
List.Free;
end;

{******************************************************************************}

procedure TMyPlaylist.Delete_Item(Item: integer);
begin
if PlaylistTitles.Count < 0 then exit;

PlaylistTitles.Delete(Item);
PlaylistPaths.Delete(Item);
PlaylistDurations.Delete(Item);
if Tracking = Item then
Tracking := -1;
Paint;
end;

{******************************************************************************}

procedure TMyPlaylist.ClearList;
begin
if PlaylistTitles.Count > 0 then
PlaylistTitles.Clear;
PlaylistPaths.Clear;
PlaylistDurations.Clear;
Tracking := -1;
Paint;
end;

{******************************************************************************}

function TMyPlaylist.Count: Integer;
begin
Result := PlaylistTitles.Count;
end;

{******************************************************************************}

function TMyPlaylist.GetTracking: Integer;
begin
Result := Tracking;
end;

{******************************************************************************}

procedure TMyPlaylist.SetNewItemTrack(Item: integer);
begin
if PlaylistTitles.Count >= Item+1 then
Tracking := Item;
Paint;
end;

{******************************************************************************}

procedure TMyPlaylist.SetNewItemSelect(Item: integer);
begin
PlaylistSelection.Add(IntToStr(Item));
Paint;
end;

{******************************************************************************}

function TMyPlaylist.GetItemFiles: TStrings;
begin
Result := PlaylistPaths;
end;

{******************************************************************************}

procedure TMyPlaylist.SetShowDuration(Value: Boolean);
begin
FShowDuration := Value;
Paint;
end;

{******************************************************************************}

procedure TMyPlaylist.SetShowNumber(Value: Boolean);
begin
FShowNumber := Value;
Paint;
end;

{******************************************************************************}

procedure TMyPlaylist.SetPosition(Value: integer);
begin
FPosition := Value;
Paint;
end;

{******************************************************************************}

function TMyPlaylist.GetItemHeight: integer;
begin
Result := ItemHeight;
end;

{******************************************************************************}

procedure TMyPlaylist.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//if (Y > ItemHeight) and (Y < ItemHeight*2) then
//SetNewItemTrack(1);
//ShowMessage('('+IntToStr(X)+';'+IntToStr(Y)+')')

// 
if Assigned(OnMouseDown) then OnMouseDown(Self,Button,Shift,X,Y);
end;

{******************************************************************************}

procedure TMyPlaylist.MouseMove (Shift: TShiftState; X, Y: Integer);
begin
X1 := X;
Y1 := Y;

// 
if Assigned(OnMouseMove) then OnMouseMove(Self,Shift,X,Y);
end;

{******************************************************************************}

procedure TMyPlaylist.DblClick;
begin
if (Y1 > ItemHeight) and (Y1 < ItemHeight*2) then
SetNewItemTrack(1);

// 
if Assigned(OnDblClick) then OnDblClick(Self);
end;

{******************************************************************************}

procedure TMyPlaylist.KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
if Assigned(OnKeyDown) then OnKeyDown(Self, Key, Shift);
end;


end.
